﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Security.Cryptography;
using System.IO;
using System.Text;
using System.IO.Compression;

/// <summary>
/// Description résumée de Class1
/// </summary>
public class Class1
{
    
    


	public Class1()
	{
		//
		// TODO: ajoutez ici la logique du constructeur
		//
	}


    

    public static string Decompress(byte[] data)
    {
        if (data == null || data.Length == 0)
        {
            return string.Empty;
        }

        // Stream on raw compressed bytes
        using (var compressedMemoryStream = new MemoryStream(data))
        {
            // Wrap with GZIP decompressing stream
            using (var gZipStream = new GZipStream(compressedMemoryStream, CompressionMode.Decompress))
            {
                // Stream reader to read decompressed string
                using (var plainTextStreamReader = new StreamReader(gZipStream))
                {
                    // Read original data
                    return plainTextStreamReader.ReadToEnd();
                }
            }
        }
    }


    public static byte[] AESDecrypt(string cipherText, byte[] key)
    {
       
        // Restore unsafe characters
        var base64 = cipherText.Replace("-", "+").Replace("_", "/");

        // Pad length - how many characters are missing to the total length of multiple of four
        var padLength = cipherText.Length % 4;

        // Restore padding
        if (padLength > 0)
        {
            base64 = base64.PadRight(cipherText.Length + 4 - padLength, '=');
        }

        // Place le texte à déchiffrer dans un tableau d'octets
        byte[] cipheredData = Convert.FromBase64String(base64);

        RijndaelManaged rijndael = new RijndaelManaged();
        rijndael.Mode = CipherMode.ECB;

        // Ecris les données déchiffrées dans le MemoryStream
        ICryptoTransform decryptor = rijndael.CreateDecryptor(key, rijndael.IV);
        MemoryStream ms = new MemoryStream(cipheredData);
        CryptoStream cs = new CryptoStream(ms, decryptor, CryptoStreamMode.Read);

        // Place les données déchiffrées dans un tableau d'octet
        byte[] plainTextData = new byte[cipheredData.Length];

        int decryptedByteCount = cs.Read(plainTextData, 0, plainTextData.Length);

        ms.Close();
        cs.Close();

        //return Encoding.UTF8.GetString(plainTextData, 0, decryptedByteCount);
        return plainTextData;
    }

    
    public static string AESEncrypt(string clearText, string strKey)
    {
        // Place le texte à chiffrer dans un tableau d'octets
        byte[] plainText = Encoding.UTF8.GetBytes(clearText);

        // Place la clé de chiffrement dans un tableau d'octets
        byte[] key = Encoding.UTF8.GetBytes(strKey);

        RijndaelManaged rijndael = new RijndaelManaged();

        // Définit le mode utilisé
        rijndael.Mode = CipherMode.ECB;

        // Crée le chiffreur AES - Rijndael
        ICryptoTransform aesEncryptor = rijndael.CreateEncryptor(key, rijndael.IV);

        MemoryStream ms = new MemoryStream();

        // Ecris les données chiffrées dans le MemoryStream
        CryptoStream cs = new CryptoStream(ms, aesEncryptor, CryptoStreamMode.Write);
        cs.Write(plainText, 0, plainText.Length);
        cs.FlushFinalBlock();

        // Place les données chiffrées dans un tableau d'octet
        byte[] CipherBytes = ms.ToArray();

        ms.Close();
        cs.Close();

        // Place les données chiffrées dans une chaine encodée en Base64
        return Convert.ToBase64String(CipherBytes);
    }

    
    //prend une string et retourne son hash256
    public static string Hash256(string stringTohash)
    {
        byte[] hashValue;
        SHA256 mySHA256 = SHA256Managed.Create();
        hashValue = mySHA256.ComputeHash(Encoding.Default.GetBytes(stringTohash));
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < hashValue.Length; i++)
        {
            sb.Append(hashValue[i].ToString("x2"));
        }
        return sb.ToString();
    }

}