﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public payment payment = new payment();
    public creditor creditor = new creditor();
    public transaction transaction = new transaction();                
    public string transactionID;
    public string orderID;
    public string version;
    public string comment;    
    
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            DirectPaymentAPI ws = new DirectPaymentAPI();
            
            //TRANSACTION
            transactionID = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("transactionID"))).Text;

            //ORDER
            orderID = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("orderID"))).Text;

            //PAYMENT            
            payment.amount = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("paymentAmount"))).Text;
            payment.mode = ((DropDownList)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("paymentMode"))).Text;
            payment.action = ((DropDownList)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("paymentFonction"))).Text;
            payment.currency = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("paymentCurrency"))).Text;
            payment.contractNumber = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("paymentContractNumber"))).Text;
            payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("paymentDifferedActionDate"))).Text; // Format : "dd/mm/yy"                                 

            //CREDITOR
            creditor.bic = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("creditorBic"))).Text;
            creditor.iban = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("creditorIban"))).Text;
            creditor.name = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("creditorName"))).Text;

            //version
            //To have more options
            version = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("version"))).Text;

            //comment  
            comment = ((TextBox)(Page.PreviousPage.FindControl("doBankTransfer").FindControl("comment"))).Text;

            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.doBankTransfer(version, payment, creditor, comment, transactionID, orderID, out transaction);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
