﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;

public partial class _Default : System.Web.UI.Page
{
    public payment payment = new payment();
    public order order = new order();
    public orderDetail orderDetail1 = new orderDetail();
    public orderDetail orderDetail2 = new orderDetail();
    public privateData privateData1 = new privateData();
    public privateData privateData2 = new privateData();
    public privateData privateData3 = new privateData();
    public privateData[] privateDataList = new privateData[3];
    public cardOut cardOut = new cardOut();
    public extendedCardType extendedCardType = new extendedCardType();
    public transaction transaction = new transaction();
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";
    public string transactionId = "";
    public addressOwner addressOwner = new addressOwner();

    public string media;
    public string version;

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            
            DirectPaymentAPI ws = new DirectPaymentAPI();

            version = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("version"))).Text;

            transactionId = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("transactionId"))).Text;
            
            // PAYMENT
            payment.amount = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("paymentAmount"))).Text;
            payment.mode = ((DropDownList)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("paymentMode"))).Text;
            payment.action = ((DropDownList)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("paymentFunction"))).Text;
            payment.currency = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("paymentCurrency"))).Text;
            payment.contractNumber = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("paymentContractNumber"))).Text;
            payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("paymentDifferedActionDate"))).Text; // Format : "dd/mm/yy"


            // ORDER
            order.@ref = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderRef"))).Text;
            order.origin = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderOrigin"))).Text;
            order.country = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderCountry"))).Text;
            order.taxes = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderTaxes"))).Text;



            order.currency = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderCurrency"))).Text;
            if (order.currency == "")
                order.currency = Resources.Resource.ORDER_CURRENCY;

            order.amount = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderAmount"))).Text;
            order.date = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDate"))).Text; // format : "dd/mm/yyyy HH24:MM"

            // ORDER DETAILS
            orderDetail1.@ref = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailRef1"))).Text;
            orderDetail1.price = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailPrice1"))).Text;
            orderDetail1.quantity = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailQuantity1"))).Text;
            orderDetail1.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailComment1"))).Value;

            orderDetail1.category = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailCategory1"))).Text;
            orderDetail1.brand = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailBrand1"))).Text;
            orderDetail1.subcategory1 = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailSubcategory11"))).Text;
            orderDetail1.subcategory2 = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailSubcategory21"))).Text;
            orderDetail1.additionalData = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailAdditionalData1"))).Text;
            orderDetail1.taxRate = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailTaxRate1"))).Text;

            orderDetail2.@ref = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailRef2"))).Text;
            orderDetail2.price = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailPrice2"))).Text;
            orderDetail2.quantity = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailQuantity2"))).Text;
            orderDetail2.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailComment2"))).Value;

            orderDetail2.category = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailCategory2"))).Text;
            orderDetail2.brand = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailBrand2"))).Text;
            orderDetail2.subcategory1 = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailSubcategory12"))).Text;
            orderDetail2.subcategory2 = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailSubcategory22"))).Text;
            orderDetail2.additionalData = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailAdditionalData2"))).Text;
            orderDetail2.taxRate = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("orderDetailTaxRate2"))).Text;

            if (orderDetail1.@ref.Length > 0 && orderDetail2.@ref.Length > 0)
            {
                order.details = new orderDetail[2];
                order.details.SetValue(orderDetail1, 0);
                order.details.SetValue(orderDetail2, 1);
            }
            else if (orderDetail1.@ref.Length > 0 && orderDetail2.@ref.Length == 0)
            {
                order.details = new orderDetail[1];
                order.details.SetValue(orderDetail1, 0);
            }
            else if (orderDetail2.@ref.Length > 0 && orderDetail1.@ref.Length == 0)
            {
                order.details = new orderDetail[1];
                order.details.SetValue(orderDetail2, 0);
            }

            string deliveryMode = ((DropDownList)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("deliveryTime"))).Text;
            string deliveryTime = ((DropDownList)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("deliveryMode"))).Text;

            order.deliveryMode = (deliveryMode == "none") ? "" : deliveryMode;
            order.deliveryTime = (deliveryTime == "none") ? "" : deliveryTime;

            order.deliveryExpectedDate = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("deliveryExpectedDate"))).Text;
            order.deliveryExpectedDelay = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("deliveryExpectedDelay"))).Text;

           
            // PRIVATE DATA (optional)            
            privateData1.key = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("privateDataKey1"))).Text;
            privateData1.value = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("privateDataValue1"))).Text;
            privateData2.key = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("privateDataKey2"))).Text;
            privateData2.value = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("privateDataValue2"))).Text;
            privateData3.key = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("privateDataKey3"))).Text;
            privateData3.value = ((TextBox)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("privateDataValue3"))).Text;

            privateDataList.SetValue(privateData1, 0);
            privateDataList.SetValue(privateData2, 1);
            privateDataList.SetValue(privateData3, 2);

            //MEDIA
            media = ((DropDownList)(Page.PreviousPage.FindControl("doReAuthorization").FindControl("media"))).Text;

            if (media == "none")
            {
                media = "";
            }
           

            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }
            
            //ws.Proxy = System.Net.WebRequest.DefaultWebProxy;

            ws.Url = "https://homologation.payline.com/V4/services/DirectPaymentAPI";

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);
            
            resultat = ws.doReAuthorization(version, transactionId, payment, order, privateDataList, media, 
                                            out transaction, out cardOut, out extendedCardType);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
