﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;

public partial class _Default : System.Web.UI.Page 
{
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";
    public string transactionID = "";
    public string comment = "";
    public transaction transaction = new transaction();

    public string version;
    public string media;

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            DirectPaymentAPI ws = new DirectPaymentAPI();
            
           comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("doReset").FindControl("comment"))).Value;
           transactionID = ((TextBox)(Page.PreviousPage.FindControl("doReset").FindControl("transactionID"))).Text;

           //version
           //To have more options
           version = ((TextBox)(Page.PreviousPage.FindControl("doReset").FindControl("version"))).Text;

           //MEDIA
           media = ((DropDownList)(Page.PreviousPage.FindControl("doReset").FindControl("media"))).Text;

           if (media == "none")
           {
               media = "";
           }

            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }
            
            //ws.Proxy = System.Net.WebRequest.DefaultWebProxy;

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.doReset(version, transactionID, comment, media, 
                                        out transaction);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
