﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;

public partial class _Default : System.Web.UI.Page
{
    public payment payment = new payment();
    public cheque cheque = new cheque();
    public order order = new order();
    public orderDetail orderDetail1 = new orderDetail();
    public orderDetail orderDetail2 = new orderDetail();
    public privateData privateData1 = new privateData();
    public privateData privateData2 = new privateData();
    public privateData privateData3 = new privateData();
    public privateData[] privateDataList = new privateData[3];
    public authorization authorization = new authorization();

    public scoringCheque scoringCheque = new scoringCheque();
    
    public transaction transaction = new transaction();
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";
    
    public string version = "";
    public string media;
    

    public string chequeNumber = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            //DirectPaymentAPI ws = new DirectPaymentAPI();

            DirectPaymentAPI ws = new DirectPaymentAPI();

            version = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("version"))).Text;

            //MEDIA
            media = ((DropDownList)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("media"))).Text;

            if (media == "none")
            {
                media = "";
            }

            //Cheque
            cheque.number = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("chequeNumber"))).Text;
            
            // PAYMENT
            payment.amount = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("paymentAmount"))).Text;
            payment.mode = ((DropDownList)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("paymentMode"))).Text;
            payment.action = ((DropDownList)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("paymentFunction"))).Text;
            payment.currency = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("paymentCurrency"))).Text;
            payment.contractNumber = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("paymentContractNumber"))).Text;
            payment.differedActionDate = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("paymentDifferedActionDate"))).Text; // Format : "dd/mm/yy"

           
            // ORDER
            order.@ref = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderRef"))).Text;
            order.origin = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderOrigin"))).Text;
            order.country = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderCountry"))).Text;
            order.taxes = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderTaxes"))).Text;

            order.currency = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderCurrency"))).Text;
            if (order.currency == "")
                order.currency = Resources.Resource.ORDER_CURRENCY;

            order.amount = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderAmount"))).Text;
            order.date = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderDate"))).Text; // format : "dd/mm/yyyy HH24:MM"

            // ORDER DETAILS
            orderDetail1.@ref = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderDetailRef1"))).Text;
            orderDetail1.price = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderDetailPrice1"))).Text;
            orderDetail1.quantity = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderDetailQuantity1"))).Text;
            orderDetail1.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderDetailComment1"))).Value;

            orderDetail2.@ref = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderDetailRef2"))).Text;
            orderDetail2.price = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderDetailPrice2"))).Text;
            orderDetail2.quantity = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderDetailQuantity2"))).Text;
            orderDetail2.comment = ((HtmlTextArea)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("orderDetailComment2"))).Value;

            order.details = new orderDetail[2];
            order.details.SetValue(orderDetail1, 0);
            order.details.SetValue(orderDetail2, 1);

            string deliveryMode = ((DropDownList)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("deliveryTime"))).Text;
            string deliveryTime = ((DropDownList)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("deliveryMode"))).Text;

            order.deliveryMode = (deliveryMode == "none") ? "" : deliveryMode;
            order.deliveryTime = (deliveryTime == "none") ? "" : deliveryTime;
            
            // PRIVATE DATA (optional)            
            privateData1.key = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("privateDataKey1"))).Text;
            privateData1.value = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("privateDataValue1"))).Text;
            privateData2.key = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("privateDataKey2"))).Text;
            privateData2.value = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("privateDataValue2"))).Text;
            privateData3.key = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("privateDataKey3"))).Text;
            privateData3.value = ((TextBox)(Page.PreviousPage.FindControl("doScoringCheque").FindControl("privateDataValue3"))).Text;

            privateDataList.SetValue(privateData1, 0);
            privateDataList.SetValue(privateData2, 1);
            privateDataList.SetValue(privateData3, 2);

           

           
            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }
            

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);
            
            resultat = ws.doScoringCheque(version, payment, cheque, order, privateDataList, media, 
                                            out transaction, out scoringCheque);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
