﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";

    public string cardNumber;
    public string expirationDate; 
    public string contractNumber= ""; 
    public string token= ""; 
    public string maskedCardNumber= ""; 
    public string virtualCard= ""; 
    public string cardType= ""; 
    public string cardProduct= ""; 
    public string acceptanceNetwork= "";
    public string bank = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            DirectPaymentAPI ws = new DirectPaymentAPI();

            contractNumber = ((TextBox)(Page.PreviousPage.FindControl("getToken").FindControl("contractNumber"))).Text;
            cardNumber = ((TextBox)(Page.PreviousPage.FindControl("getToken").FindControl("cardNumber"))).Text;
            expirationDate = ((TextBox)(Page.PreviousPage.FindControl("getToken").FindControl("expirationDate"))).Text;
           
            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.getToken(cardNumber, ref expirationDate, contractNumber, out token, out maskedCardNumber, 
                                    out virtualCard, out cardType, out cardProduct, out acceptanceNetwork, out bank);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
