﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;

public partial class _Default : System.Web.UI.Page
{
    
    public bankAccountData bankAccountData = new bankAccountData();
    public card card = new card();
    public transaction transaction = new transaction();
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";
    public addressOwner addressOwner = new addressOwner();
    public authentication3DSecure authentication3DSecure = new authentication3DSecure();
    public string mpiResult;
    public string contractNumber = "";
    public string md = "";
    public string pares = "";
    public string version = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {

            DirectPaymentAPI ws = new DirectPaymentAPI();

            version = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("version"))).Text;
            contractNumber = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("contractNumber"))).Text;

            // CARD INFO
            card.encryptionKeyId = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("encryptionKeyId"))).Text;
            card.encryptedData = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("encryptedData"))).Text;

            card.number = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("cardNumber"))).Text;
            card.type = ((DropDownList)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("cardType"))).Text;
            card.expirationDate = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("cardExpirationDate"))).Text;
            card.cvx = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("cardCrypto"))).Text;
            card.ownerBirthdayDate = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("cardOwnerBirthdayDate"))).Text;
            card.password = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("cardPassword"))).Text;

            //CARD PRESENT
            if (((DropDownList)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("cardPresent"))).Text != "")
            {
                card.cardPresent = ((DropDownList)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("cardPresent"))).Text;
            }

            card.cardholder = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("cardHolderName"))).Text; ;

            card.token = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("token"))).Text;
            
            // AUTHENTICATION 3D SECURE (optional)           
             md = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("md"))).Text;
             pares = ((TextBox)(Page.PreviousPage.FindControl("verifyAuthentication").FindControl("pares"))).Text;
             
             
            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }
            
            //ws.Proxy = System.Net.WebRequest.DefaultWebProxy;

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }
            

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);
            
            resultat = ws.verifyAuthentication(version, contractNumber, pares, md, card, out authentication3DSecure, out mpiResult);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
