﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public string alertId = "";
    public string transactionId = "";

    public string explanationCode = "";
    public string explanationLabel = "";
    public string transactionStatus = "";
    public string merchantLabel = "";
    public string posLabel = "";
    public string securityLevel = ""; 
    public string transactionDate = ""; 
    public string transactionAmount = ""; 
    public string transactionCurrency = ""; 
    public string paymentType = ""; 
    public string paymentData = ""; 
    public string holderName = ""; 
    public string referenceData = ""; 
    public string customerId = ""; 
    public string BuyerFirstName = ""; 
    public string buyerLastName = "";
    public CustomerTrans[] customerTrans;
    public PaymentMeansTrans[] paymentMeansTrans;
    public AlertsTrans[] alertsTrans;

    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            ExtendedAPI ws = new ExtendedAPI();

            alertId = Request["alertId"];
            transactionId = Request["transactionId"];
            
           
            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_EXTENDED;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_EXTENDED;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.getAlertDetails(ref alertId, ref transactionId, 
                                          out explanationCode, out explanationLabel, out transactionStatus, out merchantLabel, 
                                          out posLabel, out securityLevel, out transactionDate, out transactionAmount, 
                                          out transactionCurrency, out paymentType, out paymentData, out holderName, 
                                          out referenceData, out customerId, out BuyerFirstName, out buyerLastName, 
                                          out customerTrans, out paymentMeansTrans, out alertsTrans);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}
