﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public string transactionId;
    public string orderRef;
    public transaction transaction;
    public payment payment;
    public authorization authorization;
    public order order; 
    public buyer buyer;
    public privateData[] privateDataList;
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";
    public string startDate = "";
    public string endDate = "";
    public string version = "";
    public string transactionHistory = "N";
    public extendedCardType extendedCardType = new extendedCardType();
    public associatedTransactions[] associatedTransactionsList;
    public statusHistory[] statusHistoryList;
    public cardOut cardOut = new cardOut();

    public string media;
    public string archiveSearch = "N";
    public string contractNumber = "";

    public paymentAdditional[] paymentAdditionalList;

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            //associatedTransactionsList = new associatedTransactions[500];

            ExtendedAPI ws = new ExtendedAPI();
            
            /************************************/
            /*      	TRANSACTION DETAIL 		*/
            /************************************/

            //TRANSACTION1
            transactionId = ((TextBox)(Page.PreviousPage.FindControl("getTransactionDetails").FindControl("transactionId"))).Text;

            //ORDER REF            
            orderRef = ((TextBox)(Page.PreviousPage.FindControl("getTransactionDetails").FindControl("orderRef"))).Text;

            version = ((TextBox)(Page.PreviousPage.FindControl("getTransactionDetails").FindControl("version"))).Text;
            startDate = ((TextBox)(Page.PreviousPage.FindControl("getTransactionDetails").FindControl("startDate"))).Text;
            endDate = ((TextBox)(Page.PreviousPage.FindControl("getTransactionDetails").FindControl("endDate"))).Text;

            if (true == ((CheckBox)(Page.PreviousPage.FindControl("getTransactionDetails").FindControl("transactionHistory"))).Checked)
            {
                transactionHistory = "Y";
            }

            if (true == ((CheckBox)(Page.PreviousPage.FindControl("getTransactionDetails").FindControl("archiveSearch"))).Checked)
            {
                archiveSearch = "Y";
            }

            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_EXTENDED;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_EXTENDED;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.getTransactionDetails(version, transactionId, orderRef, startDate, endDate, transactionHistory, archiveSearch, 
                                                out transaction,
                                                out payment, 
                                                out authorization,
                                                out order, 
                                                out buyer, 
                                                out privateDataList, 
                                                out cardOut,
                                                out extendedCardType, 
                                                out associatedTransactionsList, 
                                                out statusHistoryList, 
                                                out media,
                                                out contractNumber,
                                                out paymentAdditionalList);
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }            
    }
}
