﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public recurring recurring;
    public order order;
    public billingRecord billingRecord;
    public privateData[] privateDataList;
    public string isDisabled;
    public string disableDate;
    public string walletId;
    public string contractNumber;
    public string paymentRecordId;
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";
    public string version = "";
    public string billingRecordId;

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            DirectPaymentAPI ws = new DirectPaymentAPI();

            version = ((TextBox)(Page.PreviousPage.FindControl("getBillingRecord").FindControl("version"))).Text;
            contractNumber = ((TextBox)(Page.PreviousPage.FindControl("getBillingRecord").FindControl("contractNumber"))).Text;
            paymentRecordId = ((TextBox)(Page.PreviousPage.FindControl("getBillingRecord").FindControl("paymentRecordId"))).Text;
            billingRecordId = ((TextBox)(Page.PreviousPage.FindControl("getBillingRecord").FindControl("billingRecordId"))).Text;

            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_DIRECT;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_DIRECT;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.getBillingRecord(contractNumber, paymentRecordId, billingRecordId,
                                            out recurring, out isDisabled, out disableDate, out billingRecord, out order, 
                                            out privateDataList, out walletId);

        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }   
    }
}
