﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public wallet wallet;
    public privateData[] privateDataList;    
    public string token;
    public string version = "";
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";
    public owner owner = new owner();
    public extendedCardType extendedCard;

    public string media;
    public string[] contractNumberWalletList = new string[10];
    public string numberOfAttempt;


    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            WebPaymentAPI ws = new WebPaymentAPI();
            version = ((TextBox)(Page.PreviousPage.FindControl("getWebWallet").FindControl("version"))).Text;                      
            token = ((TextBox)(Page.PreviousPage.FindControl("getWebWallet").FindControl("token"))).Text;

            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_WEB;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_WEB;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }
            
            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.getWebWallet(version, token, 
                                        out wallet, out owner, out privateDataList, out extendedCard, out media, 
                                        out numberOfAttempt, out contractNumberWalletList);           
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }            
    }
}
