﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Globalization;

public partial class _Default : System.Web.UI.Page 
{
    public result resultat;
    public string token;
    public string redirectURL;
    public bool debug;
    public payment payment = new payment();
    public order order = new order();
    public buyer buyer = new buyer();
    public recurring recurring = new recurring();
    public privateData[] privateDataList = null;
    public string errorMessage = "";
    public string errorDetails = "";
    protected CultureInfo GcuFR = new CultureInfo("fr-FR", false);
    public String[] secondSelectedContractList;
    string[] selectedCrontractList = new string[100];
    public addressOwner addressOwner = new addressOwner();
    public owner owner = new owner();

    public string[] contractNumberWalletList = new string[10];
    public string version;

    public string stepCode;
    public string reqCode;
    public string method;

    public string media;

    public string userExperience = "inShop";

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            WebPaymentAPI ws = new WebPaymentAPI();

            media = "";
            string version = ((TextBox)(Page.PreviousPage.FindControl("doWebPayment").FindControl("version"))).Text;
                        
            string amount = ((TextBox)(Page.PreviousPage.FindControl("doWebPayment").FindControl("amount"))).Text;
            string currency = ((DropDownList)(Page.PreviousPage.FindControl("doWebPayment").FindControl("currency"))).Text;
            string reference = ((TextBox)(Page.PreviousPage.FindControl("doWebPayment").FindControl("ref"))).Text;

            userExperience = ((DropDownList)(Page.PreviousPage.FindControl("doWebPayment").FindControl("userExperience"))).Text;

            payment.amount = amount;
            payment.currency = currency;
            payment.action = Resources.Resource.PAYMENT_ACTION;
            payment.mode = Resources.Resource.PAYMENT_MODE;
            payment.contractNumber = Resources.Resource.CONTRACT_NUMBER;

            order.@ref = reference;
            order.amount = amount;
            order.currency = currency;
            order.date = DateTime.Now.ToString("dd/MM/yyyy HH:mm", GcuFR.DateTimeFormat);            
            
            string contractNumberList = Resources.Resource.CONTRACT_NUMBER_LIST;           
            
            if (contractNumberList.Contains(";"))
            {
                string[] split = contractNumberList.Split(new Char[] { ';' });
                selectedCrontractList = split;
            }
            else
            {
                selectedCrontractList.SetValue(contractNumberList, 0);
            }

            recurring = null;
            buyer = null;
            contractNumberWalletList = null;

           
            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_WEB;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_WEB;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }


            
            

            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.doWebPayment(version, payment, Resources.Resource.RETURN_URL, Resources.Resource.CANCEL_URL, 
                                                order, Resources.Resource.NOTIFICATION_URL, selectedCrontractList, 
                                                secondSelectedContractList, privateDataList, 
                                                Resources.Resource.LANGUAGE_CODE, 
                                                Resources.Resource.CUSTOM_PAYMENT_PAGE_CODE, buyer, owner,
                                                Resources.Resource.SECURITY_MODE, recurring, 
                                                Resources.Resource.CUSTOM_PAYMENT_TEMPLATE_URL, contractNumberWalletList, 
                                                out token, out redirectURL, out stepCode, out reqCode, out method);

            debug = ((CheckBox)(Page.PreviousPage.FindControl("doWebPayment").FindControl("debug"))).Checked;
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }
    }
}