﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    public transaction transaction;
    public payment payment;
    public authorization authorization;
    public privateData[] privateDataList;
    public billingRecord[] billingRecord;
    public authentication3DSecure authentication3DSecure;
    public string token;
    public string version = "";
    public result resultat;
    public string errorMessage = "";
    public string errorDetails = "";
    public cardOut cardOut = new cardOut();
    public extendedCardType extendedCardType = new extendedCardType();
    public order order = new order();
    public paymentAdditional[] paymentAdditionalList;

    public wallet wallet = new wallet();
    public string media;
    public string numberOfAttempt;
    public string paymentRecordId;
    public string[] contractNumberWalletList;
    public string contractNumber;

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            WebPaymentAPI ws = new WebPaymentAPI();
                                    
            token = ((TextBox)(Page.PreviousPage.FindControl("getWebPaymentDetail").FindControl("token"))).Text;
            version = ((TextBox)(Page.PreviousPage.FindControl("getWebPaymentDetail").FindControl("version"))).Text;

            //PROXY
            if (Resources.Resource.PROXY_HOST != "" && Resources.Resource.PROXY_PORT != "")
            {
                ws.Proxy = new System.Net.WebProxy(Resources.Resource.PROXY_HOST, Convert.ToInt32(Resources.Resource.PROXY_PORT));
                if (Resources.Resource.PROXY_USER != "" && Resources.Resource.PROXY_PASSWORD != "")
                {
                    ws.Proxy.Credentials = new System.Net.NetworkCredential(Resources.Resource.PROXY_USER, Resources.Resource.PROXY_PASSWORD);
                }
            }

            if (Resources.Resource.PROD == "true")
            {
                ws.Url = Resources.Resource.ENDPOINT_WEB;
            }
            else if (Resources.Resource.PROD == "dev")
            {
                ws.Url = Resources.Resource.ENDPOINT_DEV_WEB;
                System.Net.ServicePointManager.CertificatePolicy = new TrustAllCertificatePolicy();
            }
            
            ws.Credentials = new System.Net.NetworkCredential(Resources.Resource.MERCHANT_ID, Resources.Resource.ACCESS_KEY);

            resultat = ws.getWebPaymentDetails(version, token, 
                                                out transaction, out payment, out authorization, out privateDataList, 
                                                out paymentRecordId, out billingRecord, out authentication3DSecure, 
                                                out cardOut, out extendedCardType, out order, out paymentAdditionalList, 
                                                out media, out numberOfAttempt, out wallet, out contractNumberWalletList, out contractNumber);
            
        }
        catch (Exception exc)
        {
            errorMessage = exc.Message;
            errorDetails = exc.ToString();
        }            
    }
}
